from fred_api.logger import log_entry_common_types_pb2 as _log_entry_common_types_pb2
from google.protobuf import empty_pb2 as _empty_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class CloseLogEntryReply(_message.Message):
    __slots__ = ["exception"]
    class Exception(_message.Message):
        __slots__ = ["log_entry_does_not_exist"]
        LOG_ENTRY_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        log_entry_does_not_exist: _log_entry_common_types_pb2.LogEntryDoesNotExist
        def __init__(self, log_entry_does_not_exist: _Optional[_Union[_log_entry_common_types_pb2.LogEntryDoesNotExist, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: CloseLogEntryReply.Exception
    def __init__(self, exception: _Optional[_Union[CloseLogEntryReply.Exception, _Mapping]] = ...) -> None: ...

class CloseLogEntryRequest(_message.Message):
    __slots__ = ["content", "log_entry_id", "properties", "references", "result_code", "result_name", "session_id"]
    class PropertiesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _log_entry_common_types_pb2.LogEntryPropertyValues
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_log_entry_common_types_pb2.LogEntryPropertyValues, _Mapping]] = ...) -> None: ...
    class ReferencesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _log_entry_common_types_pb2.ObjectReferenceValues
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_log_entry_common_types_pb2.ObjectReferenceValues, _Mapping]] = ...) -> None: ...
    CONTENT_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    REFERENCES_FIELD_NUMBER: _ClassVar[int]
    RESULT_CODE_FIELD_NUMBER: _ClassVar[int]
    RESULT_NAME_FIELD_NUMBER: _ClassVar[int]
    SESSION_ID_FIELD_NUMBER: _ClassVar[int]
    content: _log_entry_common_types_pb2.LogEntryContent
    log_entry_id: _log_entry_common_types_pb2.LogEntryId
    properties: _containers.MessageMap[str, _log_entry_common_types_pb2.LogEntryPropertyValues]
    references: _containers.MessageMap[str, _log_entry_common_types_pb2.ObjectReferenceValues]
    result_code: int
    result_name: str
    session_id: _log_entry_common_types_pb2.SessionId
    def __init__(self, log_entry_id: _Optional[_Union[_log_entry_common_types_pb2.LogEntryId, _Mapping]] = ..., content: _Optional[_Union[_log_entry_common_types_pb2.LogEntryContent, _Mapping]] = ..., properties: _Optional[_Mapping[str, _log_entry_common_types_pb2.LogEntryPropertyValues]] = ..., references: _Optional[_Mapping[str, _log_entry_common_types_pb2.ObjectReferenceValues]] = ..., result_code: _Optional[int] = ..., result_name: _Optional[str] = ..., session_id: _Optional[_Union[_log_entry_common_types_pb2.SessionId, _Mapping]] = ...) -> None: ...

class CloseSessionReply(_message.Message):
    __slots__ = ["exception"]
    class Exception(_message.Message):
        __slots__ = ["session_does_not_exist"]
        class SessionDoesNotExist(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        SESSION_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        session_does_not_exist: CloseSessionReply.Exception.SessionDoesNotExist
        def __init__(self, session_does_not_exist: _Optional[_Union[CloseSessionReply.Exception.SessionDoesNotExist, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: CloseSessionReply.Exception
    def __init__(self, exception: _Optional[_Union[CloseSessionReply.Exception, _Mapping]] = ...) -> None: ...

class CloseSessionRequest(_message.Message):
    __slots__ = ["session_id"]
    SESSION_ID_FIELD_NUMBER: _ClassVar[int]
    session_id: _log_entry_common_types_pb2.SessionId
    def __init__(self, session_id: _Optional[_Union[_log_entry_common_types_pb2.SessionId, _Mapping]] = ...) -> None: ...

class CreateLogEntryReply(_message.Message):
    __slots__ = ["data"]
    class Data(_message.Message):
        __slots__ = ["log_entry_id"]
        LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
        log_entry_id: _log_entry_common_types_pb2.LogEntryId
        def __init__(self, log_entry_id: _Optional[_Union[_log_entry_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: CreateLogEntryReply.Data
    def __init__(self, data: _Optional[_Union[CreateLogEntryReply.Data, _Mapping]] = ...) -> None: ...

class CreateLogEntryRequest(_message.Message):
    __slots__ = ["content", "log_entry_type", "properties", "references", "service", "session_id", "source_ip"]
    class PropertiesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _log_entry_common_types_pb2.LogEntryPropertyValues
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_log_entry_common_types_pb2.LogEntryPropertyValues, _Mapping]] = ...) -> None: ...
    class ReferencesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _log_entry_common_types_pb2.ObjectReferenceValues
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_log_entry_common_types_pb2.ObjectReferenceValues, _Mapping]] = ...) -> None: ...
    CONTENT_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_TYPE_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    REFERENCES_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    SESSION_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IP_FIELD_NUMBER: _ClassVar[int]
    content: _log_entry_common_types_pb2.LogEntryContent
    log_entry_type: _log_entry_common_types_pb2.LogEntryType
    properties: _containers.MessageMap[str, _log_entry_common_types_pb2.LogEntryPropertyValues]
    references: _containers.MessageMap[str, _log_entry_common_types_pb2.ObjectReferenceValues]
    service: _log_entry_common_types_pb2.LogEntryService
    session_id: _log_entry_common_types_pb2.SessionId
    source_ip: _log_entry_common_types_pb2.SourceIp
    def __init__(self, source_ip: _Optional[_Union[_log_entry_common_types_pb2.SourceIp, _Mapping]] = ..., service: _Optional[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]] = ..., content: _Optional[_Union[_log_entry_common_types_pb2.LogEntryContent, _Mapping]] = ..., properties: _Optional[_Mapping[str, _log_entry_common_types_pb2.LogEntryPropertyValues]] = ..., references: _Optional[_Mapping[str, _log_entry_common_types_pb2.ObjectReferenceValues]] = ..., log_entry_type: _Optional[_Union[_log_entry_common_types_pb2.LogEntryType, _Mapping]] = ..., session_id: _Optional[_Union[_log_entry_common_types_pb2.SessionId, _Mapping]] = ...) -> None: ...

class CreateSessionReply(_message.Message):
    __slots__ = ["data"]
    class Data(_message.Message):
        __slots__ = ["session_id"]
        SESSION_ID_FIELD_NUMBER: _ClassVar[int]
        session_id: _log_entry_common_types_pb2.SessionId
        def __init__(self, session_id: _Optional[_Union[_log_entry_common_types_pb2.SessionId, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: CreateSessionReply.Data
    def __init__(self, data: _Optional[_Union[CreateSessionReply.Data, _Mapping]] = ...) -> None: ...

class CreateSessionRequest(_message.Message):
    __slots__ = ["user_id", "username"]
    USERNAME_FIELD_NUMBER: _ClassVar[int]
    USER_ID_FIELD_NUMBER: _ClassVar[int]
    user_id: _log_entry_common_types_pb2.UserId
    username: _log_entry_common_types_pb2.Username
    def __init__(self, user_id: _Optional[_Union[_log_entry_common_types_pb2.UserId, _Mapping]] = ..., username: _Optional[_Union[_log_entry_common_types_pb2.Username, _Mapping]] = ...) -> None: ...

class GetLogEntryTypesReply(_message.Message):
    __slots__ = ["data"]
    class Data(_message.Message):
        __slots__ = ["types"]
        TYPES_FIELD_NUMBER: _ClassVar[int]
        types: _containers.RepeatedCompositeFieldContainer[_log_entry_common_types_pb2.LogEntryType]
        def __init__(self, types: _Optional[_Iterable[_Union[_log_entry_common_types_pb2.LogEntryType, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: GetLogEntryTypesReply.Data
    def __init__(self, data: _Optional[_Union[GetLogEntryTypesReply.Data, _Mapping]] = ...) -> None: ...

class GetLogEntryTypesRequest(_message.Message):
    __slots__ = ["service"]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    service: _log_entry_common_types_pb2.LogEntryService
    def __init__(self, service: _Optional[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]] = ...) -> None: ...

class GetObjectReferenceTypesReply(_message.Message):
    __slots__ = ["data"]
    class Data(_message.Message):
        __slots__ = ["object_types"]
        OBJECT_TYPES_FIELD_NUMBER: _ClassVar[int]
        object_types: _containers.RepeatedCompositeFieldContainer[_log_entry_common_types_pb2.ObjectReferenceType]
        def __init__(self, object_types: _Optional[_Iterable[_Union[_log_entry_common_types_pb2.ObjectReferenceType, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: GetObjectReferenceTypesReply.Data
    def __init__(self, data: _Optional[_Union[GetObjectReferenceTypesReply.Data, _Mapping]] = ...) -> None: ...

class GetResultsReply(_message.Message):
    __slots__ = ["data"]
    class Data(_message.Message):
        __slots__ = ["result_code_map"]
        class ResultCodeMapEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: int
            def __init__(self, key: _Optional[str] = ..., value: _Optional[int] = ...) -> None: ...
        RESULT_CODE_MAP_FIELD_NUMBER: _ClassVar[int]
        result_code_map: _containers.ScalarMap[str, int]
        def __init__(self, result_code_map: _Optional[_Mapping[str, int]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: GetResultsReply.Data
    def __init__(self, data: _Optional[_Union[GetResultsReply.Data, _Mapping]] = ...) -> None: ...

class GetResultsRequest(_message.Message):
    __slots__ = ["service"]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    service: _log_entry_common_types_pb2.LogEntryService
    def __init__(self, service: _Optional[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]] = ...) -> None: ...

class GetServicesReply(_message.Message):
    __slots__ = ["data"]
    class Data(_message.Message):
        __slots__ = ["services"]
        SERVICES_FIELD_NUMBER: _ClassVar[int]
        services: _containers.RepeatedCompositeFieldContainer[_log_entry_common_types_pb2.LogEntryService]
        def __init__(self, services: _Optional[_Iterable[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: GetServicesReply.Data
    def __init__(self, data: _Optional[_Union[GetServicesReply.Data, _Mapping]] = ...) -> None: ...

class RegisterLogEntryTypesRequest(_message.Message):
    __slots__ = ["log_entry_types", "service"]
    LOG_ENTRY_TYPES_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    log_entry_types: _containers.RepeatedCompositeFieldContainer[_log_entry_common_types_pb2.LogEntryType]
    service: _log_entry_common_types_pb2.LogEntryService
    def __init__(self, service: _Optional[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]] = ..., log_entry_types: _Optional[_Iterable[_Union[_log_entry_common_types_pb2.LogEntryType, _Mapping]]] = ...) -> None: ...

class RegisterObjectReferenceTypesRequest(_message.Message):
    __slots__ = ["object_types"]
    OBJECT_TYPES_FIELD_NUMBER: _ClassVar[int]
    object_types: _containers.RepeatedCompositeFieldContainer[_log_entry_common_types_pb2.ObjectReferenceType]
    def __init__(self, object_types: _Optional[_Iterable[_Union[_log_entry_common_types_pb2.ObjectReferenceType, _Mapping]]] = ...) -> None: ...

class RegisterResultsRequest(_message.Message):
    __slots__ = ["results", "service"]
    RESULTS_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    results: _containers.RepeatedCompositeFieldContainer[Result]
    service: _log_entry_common_types_pb2.LogEntryService
    def __init__(self, service: _Optional[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]] = ..., results: _Optional[_Iterable[_Union[Result, _Mapping]]] = ...) -> None: ...

class RegisterServiceRequest(_message.Message):
    __slots__ = ["service_handle", "service_name"]
    SERVICE_HANDLE_FIELD_NUMBER: _ClassVar[int]
    SERVICE_NAME_FIELD_NUMBER: _ClassVar[int]
    service_handle: str
    service_name: _log_entry_common_types_pb2.LogEntryService
    def __init__(self, service_name: _Optional[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]] = ..., service_handle: _Optional[str] = ...) -> None: ...

class Result(_message.Message):
    __slots__ = ["code", "name"]
    CODE_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    code: int
    name: str
    def __init__(self, code: _Optional[int] = ..., name: _Optional[str] = ...) -> None: ...
