from fred_api.logger import log_entry_common_types_pb2 as _log_entry_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class GetLogEntryInfoReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["log_entry_info"]
        LOG_ENTRY_INFO_FIELD_NUMBER: _ClassVar[int]
        log_entry_info: LogEntryInfo
        def __init__(self, log_entry_info: _Optional[_Union[LogEntryInfo, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["log_entry_does_not_exist"]
        LOG_ENTRY_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        log_entry_does_not_exist: _log_entry_common_types_pb2.LogEntryDoesNotExist
        def __init__(self, log_entry_does_not_exist: _Optional[_Union[_log_entry_common_types_pb2.LogEntryDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: GetLogEntryInfoReply.Data
    exception: GetLogEntryInfoReply.Exception
    def __init__(self, data: _Optional[_Union[GetLogEntryInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[GetLogEntryInfoReply.Exception, _Mapping]] = ...) -> None: ...

class GetLogEntryInfoRequest(_message.Message):
    __slots__ = ["log_entry_id"]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    log_entry_id: _log_entry_common_types_pb2.LogEntryId
    def __init__(self, log_entry_id: _Optional[_Union[_log_entry_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class ListLogEntriesReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["log_entry_ids"]
        LOG_ENTRY_IDS_FIELD_NUMBER: _ClassVar[int]
        log_entry_ids: _containers.RepeatedCompositeFieldContainer[_log_entry_common_types_pb2.LogEntryId]
        def __init__(self, log_entry_ids: _Optional[_Iterable[_Union[_log_entry_common_types_pb2.LogEntryId, _Mapping]]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["invalid_count_limit", "invalid_timestamp_from", "invalid_timestamp_range", "invalid_timestamp_to", "log_entry_service_not_found"]
        class InvalidCountLimit(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        class InvalidTimestampFrom(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        class InvalidTimestampRange(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        class InvalidTimestampTo(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        class LogEntryServiceNotFound(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        INVALID_COUNT_LIMIT_FIELD_NUMBER: _ClassVar[int]
        INVALID_TIMESTAMP_FROM_FIELD_NUMBER: _ClassVar[int]
        INVALID_TIMESTAMP_RANGE_FIELD_NUMBER: _ClassVar[int]
        INVALID_TIMESTAMP_TO_FIELD_NUMBER: _ClassVar[int]
        LOG_ENTRY_SERVICE_NOT_FOUND_FIELD_NUMBER: _ClassVar[int]
        invalid_count_limit: ListLogEntriesReply.Exception.InvalidCountLimit
        invalid_timestamp_from: ListLogEntriesReply.Exception.InvalidTimestampFrom
        invalid_timestamp_range: ListLogEntriesReply.Exception.InvalidTimestampRange
        invalid_timestamp_to: ListLogEntriesReply.Exception.InvalidTimestampTo
        log_entry_service_not_found: ListLogEntriesReply.Exception.LogEntryServiceNotFound
        def __init__(self, log_entry_service_not_found: _Optional[_Union[ListLogEntriesReply.Exception.LogEntryServiceNotFound, _Mapping]] = ..., invalid_timestamp_from: _Optional[_Union[ListLogEntriesReply.Exception.InvalidTimestampFrom, _Mapping]] = ..., invalid_timestamp_to: _Optional[_Union[ListLogEntriesReply.Exception.InvalidTimestampTo, _Mapping]] = ..., invalid_timestamp_range: _Optional[_Union[ListLogEntriesReply.Exception.InvalidTimestampRange, _Mapping]] = ..., invalid_count_limit: _Optional[_Union[ListLogEntriesReply.Exception.InvalidCountLimit, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ListLogEntriesReply.Data
    exception: ListLogEntriesReply.Exception
    def __init__(self, data: _Optional[_Union[ListLogEntriesReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ListLogEntriesReply.Exception, _Mapping]] = ...) -> None: ...

class ListLogEntriesRequest(_message.Message):
    __slots__ = ["count_limit", "log_entry_types", "properties", "reference", "service", "timestamp_from", "timestamp_to", "user_id", "username"]
    COUNT_LIMIT_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_TYPES_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    REFERENCE_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    TIMESTAMP_FROM_FIELD_NUMBER: _ClassVar[int]
    TIMESTAMP_TO_FIELD_NUMBER: _ClassVar[int]
    USERNAME_FIELD_NUMBER: _ClassVar[int]
    USER_ID_FIELD_NUMBER: _ClassVar[int]
    count_limit: int
    log_entry_types: _containers.RepeatedCompositeFieldContainer[_log_entry_common_types_pb2.LogEntryType]
    properties: _containers.RepeatedCompositeFieldContainer[_log_entry_common_types_pb2.LogEntryProperty]
    reference: _log_entry_common_types_pb2.ObjectReference
    service: _log_entry_common_types_pb2.LogEntryService
    timestamp_from: _timestamp_pb2.Timestamp
    timestamp_to: _timestamp_pb2.Timestamp
    user_id: _log_entry_common_types_pb2.UserId
    username: _log_entry_common_types_pb2.Username
    def __init__(self, username: _Optional[_Union[_log_entry_common_types_pb2.Username, _Mapping]] = ..., user_id: _Optional[_Union[_log_entry_common_types_pb2.UserId, _Mapping]] = ..., timestamp_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., timestamp_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., service: _Optional[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]] = ..., log_entry_types: _Optional[_Iterable[_Union[_log_entry_common_types_pb2.LogEntryType, _Mapping]]] = ..., reference: _Optional[_Union[_log_entry_common_types_pb2.ObjectReference, _Mapping]] = ..., count_limit: _Optional[int] = ..., properties: _Optional[_Iterable[_Union[_log_entry_common_types_pb2.LogEntryProperty, _Mapping]]] = ...) -> None: ...

class LogEntryInfo(_message.Message):
    __slots__ = ["input_properties", "log_entry_id", "log_entry_type", "output_properties", "properties", "raw_request", "raw_response", "references", "result_code", "result_name", "service", "session_id", "source_ip", "time_begin", "time_end", "user_id", "username"]
    class InputPropertiesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _log_entry_common_types_pb2.LogEntryPropertyValues
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_log_entry_common_types_pb2.LogEntryPropertyValues, _Mapping]] = ...) -> None: ...
    class OutputPropertiesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _log_entry_common_types_pb2.LogEntryPropertyValues
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_log_entry_common_types_pb2.LogEntryPropertyValues, _Mapping]] = ...) -> None: ...
    class PropertiesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _log_entry_common_types_pb2.LogEntryPropertyValues
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_log_entry_common_types_pb2.LogEntryPropertyValues, _Mapping]] = ...) -> None: ...
    class ReferencesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: _log_entry_common_types_pb2.ObjectReferenceValues
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[_log_entry_common_types_pb2.ObjectReferenceValues, _Mapping]] = ...) -> None: ...
    INPUT_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_TYPE_FIELD_NUMBER: _ClassVar[int]
    OUTPUT_PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    PROPERTIES_FIELD_NUMBER: _ClassVar[int]
    RAW_REQUEST_FIELD_NUMBER: _ClassVar[int]
    RAW_RESPONSE_FIELD_NUMBER: _ClassVar[int]
    REFERENCES_FIELD_NUMBER: _ClassVar[int]
    RESULT_CODE_FIELD_NUMBER: _ClassVar[int]
    RESULT_NAME_FIELD_NUMBER: _ClassVar[int]
    SERVICE_FIELD_NUMBER: _ClassVar[int]
    SESSION_ID_FIELD_NUMBER: _ClassVar[int]
    SOURCE_IP_FIELD_NUMBER: _ClassVar[int]
    TIME_BEGIN_FIELD_NUMBER: _ClassVar[int]
    TIME_END_FIELD_NUMBER: _ClassVar[int]
    USERNAME_FIELD_NUMBER: _ClassVar[int]
    USER_ID_FIELD_NUMBER: _ClassVar[int]
    input_properties: _containers.MessageMap[str, _log_entry_common_types_pb2.LogEntryPropertyValues]
    log_entry_id: _log_entry_common_types_pb2.LogEntryId
    log_entry_type: _log_entry_common_types_pb2.LogEntryType
    output_properties: _containers.MessageMap[str, _log_entry_common_types_pb2.LogEntryPropertyValues]
    properties: _containers.MessageMap[str, _log_entry_common_types_pb2.LogEntryPropertyValues]
    raw_request: _log_entry_common_types_pb2.LogEntryContent
    raw_response: _log_entry_common_types_pb2.LogEntryContent
    references: _containers.MessageMap[str, _log_entry_common_types_pb2.ObjectReferenceValues]
    result_code: int
    result_name: str
    service: _log_entry_common_types_pb2.LogEntryService
    session_id: _log_entry_common_types_pb2.SessionId
    source_ip: _log_entry_common_types_pb2.SourceIp
    time_begin: _timestamp_pb2.Timestamp
    time_end: _timestamp_pb2.Timestamp
    user_id: _log_entry_common_types_pb2.UserId
    username: _log_entry_common_types_pb2.Username
    def __init__(self, time_begin: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., time_end: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., source_ip: _Optional[_Union[_log_entry_common_types_pb2.SourceIp, _Mapping]] = ..., service: _Optional[_Union[_log_entry_common_types_pb2.LogEntryService, _Mapping]] = ..., log_entry_type: _Optional[_Union[_log_entry_common_types_pb2.LogEntryType, _Mapping]] = ..., result_code: _Optional[int] = ..., result_name: _Optional[str] = ..., raw_request: _Optional[_Union[_log_entry_common_types_pb2.LogEntryContent, _Mapping]] = ..., raw_response: _Optional[_Union[_log_entry_common_types_pb2.LogEntryContent, _Mapping]] = ..., username: _Optional[_Union[_log_entry_common_types_pb2.Username, _Mapping]] = ..., user_id: _Optional[_Union[_log_entry_common_types_pb2.UserId, _Mapping]] = ..., properties: _Optional[_Mapping[str, _log_entry_common_types_pb2.LogEntryPropertyValues]] = ..., references: _Optional[_Mapping[str, _log_entry_common_types_pb2.ObjectReferenceValues]] = ..., input_properties: _Optional[_Mapping[str, _log_entry_common_types_pb2.LogEntryPropertyValues]] = ..., output_properties: _Optional[_Mapping[str, _log_entry_common_types_pb2.LogEntryPropertyValues]] = ..., log_entry_id: _Optional[_Union[_log_entry_common_types_pb2.LogEntryId, _Mapping]] = ..., session_id: _Optional[_Union[_log_entry_common_types_pb2.SessionId, _Mapping]] = ...) -> None: ...
